using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace MetaLabLogoProject
{
    public interface IParticleSystem
    {
        /// <summary>
        /// Steps the particle system the specified amount.
        /// </summary>
        void Step(double timeDelta);

        /// <summary>
        /// Renders the particle system to the given graphics context without clearing it.
        /// The non clearing property ensures the ability to implement various feedback effects.
        /// </summary>
        void Render(Graphics graphicsContext);
    }
}
