using System;
using System.Collections.Generic;
using System.Text;

namespace MetaLabLogoProject
{
    class Vector3<T,C>
        where C:ICalculator<T>,new()
    {
        Number<T,C> x, y, z;

        public Vector3()
        {
        }

        public Vector3(Vector3<T, C> other)
        {
            x = other.x;
            y = other.y;
            z = other.z;
        }

        public Vector3(T _x, T _y, T _z)
        {
            x = _x;
            y = _y;
            z = _z;
        }

        public T X { get { return x; } set { x = value; } }
        public T Y { get { return y; } set { y = value; } }
        public T Z { get { return z; } set { z = value; } }

        public T Length { get { return (x*x + y*y + z*z).Sqrt(); } }
        public T LengthSquared { get { return (x*x + y * y + z * z); } }

        public void Normalize()
        {
            Number<T,C> length = Length;
            x /= length;
            y /= length;
            z /= length;
        }

        public void Add(Vector3<T, C> other)
        {
            x += other.x;
            y += other.y;
            z += other.z;
        }

        public void Sub(Vector3<T, C> other)
        {
            x -= other.x;
            y -= other.y;
            z -= other.z;
        }

        public void ScalarMultiply(T scalar)
        {
            x *= scalar;
            y *= scalar;
            z *= scalar;
        }

        public static Vector3<T, C> operator +(Vector3<T, C> a, Vector3<T, C> b)
        {
            Vector3<T, C> result = new Vector3<T, C>(a);
            result.Add(b);
            return result;
        }

        public static Vector3<T, C> operator -(Vector3<T, C> a, Vector3<T, C> b)
        {
            Vector3<T, C> result = new Vector3<T, C>(a);
            result.Add(b);
            return result;
        }

    }
}
